From f84c98bdb728df6496f755659382430a2959c03b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 27 2020 21:26:54 +0000
Subject: [PATCH 1587/2232] Implement derive(Debug) on shared structs and enums


---

diff --git a/macro/src/derive.rs b/macro/src/derive.rs
index 8988012..87f8ec5 100644
--- a/macro/src/derive.rs
+++ b/macro/src/derive.rs
@@ -1,5 +1,5 @@
 use crate::syntax::{Enum, Struct, Trait};
-use proc_macro2::{Span, TokenStream};
+use proc_macro2::{Ident, Span, TokenStream};
 use quote::{quote, quote_spanned, ToTokens};
 
 pub fn expand_struct(strct: &Struct) -> TokenStream {
@@ -10,6 +10,7 @@ pub fn expand_struct(strct: &Struct) -> TokenStream {
         match derive.what {
             Trait::Copy => expanded.extend(struct_copy(strct, span)),
             Trait::Clone => expanded.extend(struct_clone(strct, span)),
+            Trait::Debug => expanded.extend(struct_debug(strct, span)),
         }
     }
 
@@ -32,6 +33,7 @@ pub fn expand_enum(enm: &Enum) -> TokenStream {
                 expanded.extend(enum_clone(enm, span));
                 has_clone = true;
             }
+            Trait::Debug => expanded.extend(enum_debug(enm, span)),
         }
     }
 
@@ -86,6 +88,23 @@ fn struct_clone(strct: &Struct, span: Span) -> TokenStream {
     }
 }
 
+fn struct_debug(strct: &Struct, span: Span) -> TokenStream {
+    let ident = &strct.name.rust;
+    let struct_name = ident.to_string();
+    let fields = strct.fields.iter().map(|field| &field.ident);
+    let field_names = fields.clone().map(Ident::to_string);
+
+    quote_spanned! {span=>
+        impl ::std::fmt::Debug for #ident {
+            fn fmt(&self, formatter: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
+                formatter.debug_struct(#struct_name)
+                    #(.field(#field_names, &self.#fields))*
+                    .finish()
+            }
+        }
+    }
+}
+
 fn enum_copy(enm: &Enum, span: Span) -> TokenStream {
     let ident = &enm.name.rust;
 
@@ -105,3 +124,26 @@ fn enum_clone(enm: &Enum, span: Span) -> TokenStream {
         }
     }
 }
+
+fn enum_debug(enm: &Enum, span: Span) -> TokenStream {
+    let ident = &enm.name.rust;
+    let variants = enm.variants.iter().map(|variant| {
+        let variant = &variant.ident;
+        let name = variant.to_string();
+        quote_spanned! {span=>
+            #ident::#variant => formatter.write_str(#name),
+        }
+    });
+    let fallback = format!("{}({{}})", ident);
+
+    quote_spanned! {span=>
+        impl ::std::fmt::Debug for #ident {
+            fn fmt(&self, formatter: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
+                match *self {
+                    #(#variants)*
+                    _ => ::std::write!(formatter, #fallback, self.repr),
+                }
+            }
+        }
+    }
+}
diff --git a/syntax/derive.rs b/syntax/derive.rs
index 501dd61..75fc6b1 100644
--- a/syntax/derive.rs
+++ b/syntax/derive.rs
@@ -10,6 +10,7 @@ pub struct Derive {
 pub enum Trait {
     Clone,
     Copy,
+    Debug,
 }
 
 impl Derive {
@@ -17,6 +18,7 @@ impl Derive {
         let what = match ident.to_string().as_str() {
             "Clone" => Trait::Clone,
             "Copy" => Trait::Copy,
+            "Debug" => Trait::Debug,
             _ => return None,
         };
         let span = ident.span();

